﻿using InitializerModel;
using PhihongEv.Lib;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace AwInitilizer.Model
{
    public class UpdateData : INotifyPropertyChanged
    {
        private SystemID _SystemID;
        public SystemID SystemID {
            get => _SystemID;
            set
            {
                if(_SystemID!=value)
                {
                    _SystemID = value;
                    RaisePropertyChanged("SystemID");
                }
            }
        }

        private string _ModelName;
        public string ModelName {
            get => _ModelName;
            set
            {
                if(_ModelName!=value)
                {
                    _ModelName = value;
                    RaisePropertyChanged("ModelName");
                }
            }
        }

        private string _SerialNumber;
        public string SerialNumber
        {
            get => _SerialNumber;
            set
            {
                if (_SerialNumber != value)
                {
                    _SerialNumber = value;
                    RaisePropertyChanged("SerialNumber");
                }
            }
        }

        private string _FourGenModuleVersion;
        public string FourGenModuleVersion
        {
            get => _FourGenModuleVersion;
            set
            {
                if (_FourGenModuleVersion != value)
                {
                    _FourGenModuleVersion = value;
                    RaisePropertyChanged("FourGenModuleVersion");
                }
            }
        }

        private string _SubFourGenModuleVersion;
        public string SubFourGenModuleVersion
        {
            get => _SubFourGenModuleVersion;
            set
            {
                if (_SubFourGenModuleVersion != value)
                {
                    _SubFourGenModuleVersion = value;
                    RaisePropertyChanged("SubFourGenModuleVersion");
                }
            }
        }

        private bool _IsSimInsert;
        public bool IsSimInsert
        {
            get => _IsSimInsert;
            set
            {
                if(_IsSimInsert != value)
                {
                    _IsSimInsert = value;
                    RaisePropertyChanged("IsSimInsert");
                }
            }
        }

        private string _SimICCID;
        public string SimICCID {
            get => _SimICCID;
            set
            {
                if (_SimICCID != value)
                {
                    _SimICCID = value;
                    RaisePropertyChanged("SimICCID");
                    RaisePropertyChanged("UiSimICCID");
                }
            }
        }

        private string _SimIMSI;
        public string SimIMSI
        {
            get => _SimIMSI;
            set
            {
                if (_SimIMSI != value)
                {
                    _SimIMSI = value;
                    RaisePropertyChanged("SimIMSI");
                    RaisePropertyChanged("UiSimIMSI");
                }
            }
        }

        private bool _IsSubSimInsert;
        public bool IsSubSimInsert
        {
            get => _IsSubSimInsert;
            set
            {
                if(_IsSubSimInsert != value)
                {
                    _IsSubSimInsert = value;
                    RaisePropertyChanged("IsSubSimInsert");
                }
            }
        }

        private string _SubSimICCID;
        public string SubSimICCID
        {
            get => _SubSimICCID;
            set
            {
                if (_SubSimICCID != value)
                {
                    _SubSimICCID = value;
                    RaisePropertyChanged("SubSimICCID");
                    RaisePropertyChanged("UiSimICCID");
                }
            }
        }

        private string _SubSimIMSI;
        public string SubSimIMSI
        {
            get => _SubSimIMSI;
            set
            {
                if (_SubSimIMSI != value)
                {
                    _SubSimIMSI = value;
                    RaisePropertyChanged("SubSimIMSI");
                    RaisePropertyChanged("UiSimIMSI");
                }
            }
        }

        public string UiSimICCID => string.IsNullOrEmpty(SubSimICCID) ? SimICCID : $"{SimICCID}/{SubSimICCID}";
        public string UiSimIMSI => string.IsNullOrEmpty(SubSimIMSI) ? SimIMSI : $"{SimIMSI}/{SubSimIMSI}";

        private ButtonTestModeType _ButtonTestMode;
        public ButtonTestModeType ButtonTestMode
        {
            get => _ButtonTestMode;
            set
            {
                if (_ButtonTestMode != value)
                {
                    _ButtonTestMode = value;
                    RaisePropertyChanged("ButtonTestMode");
                }
            }
        }

        //private bool _SkipEmergencyButton;
        //public bool SkipEmergencyButton
        //{
        //    get => _SkipEmergencyButton;
        //    set
        //    {
        //        if (_SkipEmergencyButton != value)
        //        {
        //            _SkipEmergencyButton = value;
        //            RaisePropertyChanged("SkipEmergencyButton");
        //        }
        //    }
        //}

        //private bool _SkipButtonTest;
        //public bool SkipButtonTest
        //{
        //    get => _SkipButtonTest;
        //    set
        //    {
        //        if (_SkipButtonTest != value)
        //        {
        //            _SkipButtonTest = value;
        //            RaisePropertyChanged("SkipButtonTest");
        //        }
        //    }
        //}

        private string _IpAddress;
        public string IpAddress
        {
            get => _IpAddress;
            set
            {
                if (_IpAddress != value)
                {
                    _IpAddress = value;
                    RaisePropertyChanged("IpAddress");
                }
            }
        }

        private bool _IsDisableAuthRequired;
        public bool IsDisableAuthRequired
        {
            get => _IsDisableAuthRequired;
            set
            {
                if (_IsDisableAuthRequired != value)
                {
                    _IsDisableAuthRequired = value;
                    RaisePropertyChanged("IsDisableAuthRequired");
                }
            }
        }

        private List<FirmwareUpdateModel> _FirmwareUpdateModels;
        public List<FirmwareUpdateModel> FirmwareUpdateModels
        {
            get => _FirmwareUpdateModels;
            set
            {
                if (_FirmwareUpdateModels != value)
                {
                    _FirmwareUpdateModels = value;
                    RaisePropertyChanged("FirmwareUpdateModels");
                }
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;
        internal void RaisePropertyChanged(string name)
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(name));
        }
    }
}
